/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SnapchatLookupConnectorFormAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SnapchatLookupConnectorFormAllOf{}

// SnapchatLookupConnectorFormAllOf struct for SnapchatLookupConnectorFormAllOf
type SnapchatLookupConnectorFormAllOf struct {
	// OAuthId
	OAuthId *string `json:"oAuthId,omitempty"`
	// Data source label
	Label *string `json:"label,omitempty"`
	// Snapchat Organization identifier
	OrganizationId *string `json:"organizationId,omitempty"`
	// Snapchat Ad Account identifier
	AccountId *string `json:"accountId,omitempty"`
	// Level
	Level *string `json:"level,omitempty"`
	// Snapchat attributes
	Attribute []string `json:"attribute,omitempty"`
}

// NewSnapchatLookupConnectorFormAllOf instantiates a new SnapchatLookupConnectorFormAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSnapchatLookupConnectorFormAllOf() *SnapchatLookupConnectorFormAllOf {
	this := SnapchatLookupConnectorFormAllOf{}
	return &this
}

// NewSnapchatLookupConnectorFormAllOfWithDefaults instantiates a new SnapchatLookupConnectorFormAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSnapchatLookupConnectorFormAllOfWithDefaults() *SnapchatLookupConnectorFormAllOf {
	this := SnapchatLookupConnectorFormAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *SnapchatLookupConnectorFormAllOf) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatLookupConnectorFormAllOf) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *SnapchatLookupConnectorFormAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *SnapchatLookupConnectorFormAllOf) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *SnapchatLookupConnectorFormAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatLookupConnectorFormAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *SnapchatLookupConnectorFormAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *SnapchatLookupConnectorFormAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetOrganizationId returns the OrganizationId field value if set, zero value otherwise.
func (o *SnapchatLookupConnectorFormAllOf) GetOrganizationId() string {
	if o == nil || IsNil(o.OrganizationId) {
		var ret string
		return ret
	}
	return *o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatLookupConnectorFormAllOf) GetOrganizationIdOk() (*string, bool) {
	if o == nil || IsNil(o.OrganizationId) {
		return nil, false
	}
	return o.OrganizationId, true
}

// HasOrganizationId returns a boolean if a field has been set.
func (o *SnapchatLookupConnectorFormAllOf) HasOrganizationId() bool {
	if o != nil && !IsNil(o.OrganizationId) {
		return true
	}

	return false
}

// SetOrganizationId gets a reference to the given string and assigns it to the OrganizationId field.
func (o *SnapchatLookupConnectorFormAllOf) SetOrganizationId(v string) {
	o.OrganizationId = &v
}

// GetAccountId returns the AccountId field value if set, zero value otherwise.
func (o *SnapchatLookupConnectorFormAllOf) GetAccountId() string {
	if o == nil || IsNil(o.AccountId) {
		var ret string
		return ret
	}
	return *o.AccountId
}

// GetAccountIdOk returns a tuple with the AccountId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatLookupConnectorFormAllOf) GetAccountIdOk() (*string, bool) {
	if o == nil || IsNil(o.AccountId) {
		return nil, false
	}
	return o.AccountId, true
}

// HasAccountId returns a boolean if a field has been set.
func (o *SnapchatLookupConnectorFormAllOf) HasAccountId() bool {
	if o != nil && !IsNil(o.AccountId) {
		return true
	}

	return false
}

// SetAccountId gets a reference to the given string and assigns it to the AccountId field.
func (o *SnapchatLookupConnectorFormAllOf) SetAccountId(v string) {
	o.AccountId = &v
}

// GetLevel returns the Level field value if set, zero value otherwise.
func (o *SnapchatLookupConnectorFormAllOf) GetLevel() string {
	if o == nil || IsNil(o.Level) {
		var ret string
		return ret
	}
	return *o.Level
}

// GetLevelOk returns a tuple with the Level field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatLookupConnectorFormAllOf) GetLevelOk() (*string, bool) {
	if o == nil || IsNil(o.Level) {
		return nil, false
	}
	return o.Level, true
}

// HasLevel returns a boolean if a field has been set.
func (o *SnapchatLookupConnectorFormAllOf) HasLevel() bool {
	if o != nil && !IsNil(o.Level) {
		return true
	}

	return false
}

// SetLevel gets a reference to the given string and assigns it to the Level field.
func (o *SnapchatLookupConnectorFormAllOf) SetLevel(v string) {
	o.Level = &v
}

// GetAttribute returns the Attribute field value if set, zero value otherwise.
func (o *SnapchatLookupConnectorFormAllOf) GetAttribute() []string {
	if o == nil || IsNil(o.Attribute) {
		var ret []string
		return ret
	}
	return o.Attribute
}

// GetAttributeOk returns a tuple with the Attribute field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatLookupConnectorFormAllOf) GetAttributeOk() ([]string, bool) {
	if o == nil || IsNil(o.Attribute) {
		return nil, false
	}
	return o.Attribute, true
}

// HasAttribute returns a boolean if a field has been set.
func (o *SnapchatLookupConnectorFormAllOf) HasAttribute() bool {
	if o != nil && !IsNil(o.Attribute) {
		return true
	}

	return false
}

// SetAttribute gets a reference to the given []string and assigns it to the Attribute field.
func (o *SnapchatLookupConnectorFormAllOf) SetAttribute(v []string) {
	o.Attribute = v
}

func (o SnapchatLookupConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SnapchatLookupConnectorFormAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.OrganizationId) {
		toSerialize["organizationId"] = o.OrganizationId
	}
	if !IsNil(o.AccountId) {
		toSerialize["accountId"] = o.AccountId
	}
	if !IsNil(o.Level) {
		toSerialize["level"] = o.Level
	}
	if !IsNil(o.Attribute) {
		toSerialize["attribute"] = o.Attribute
	}
	return toSerialize, nil
}

type NullableSnapchatLookupConnectorFormAllOf struct {
	value *SnapchatLookupConnectorFormAllOf
	isSet bool
}

func (v NullableSnapchatLookupConnectorFormAllOf) Get() *SnapchatLookupConnectorFormAllOf {
	return v.value
}

func (v *NullableSnapchatLookupConnectorFormAllOf) Set(val *SnapchatLookupConnectorFormAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableSnapchatLookupConnectorFormAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableSnapchatLookupConnectorFormAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSnapchatLookupConnectorFormAllOf(val *SnapchatLookupConnectorFormAllOf) *NullableSnapchatLookupConnectorFormAllOf {
	return &NullableSnapchatLookupConnectorFormAllOf{value: val, isSet: true}
}

func (v NullableSnapchatLookupConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSnapchatLookupConnectorFormAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
